package net.klakegg.master.logger

class RecordController {

    def start =
	{
		Code code = Code.findByCode(params.c)

		if (code == null)
		{
			redirect(uri:"/")
			return
		}
		
		if (params.type == "continue")
		{
			Runner r = new Runner([code:code, label:""])
			r.save(flush: true)
			
			session.runner = r
			session.remaining = []
			for (def u : code.suite.usecases)
				session.remaining.add(u.id)

			redirect(action:"record")
			return
		}
		
		[code:code]
	}
	
	def record =
	{
		if (!session.runner)
		{
			redirect(uri:"/")
			return
		}
		
		if (!session.eventholder)
		{
			redirect(action:"task")
			return
		}
		
		[usecase: session.eventholder.usecase]
	}
	
	def proxy = 
	{
		if (!session.eventholder)
		{
			redirect(action:"record")
			return
		}
		
		if (Goal.findByUsecaseAndUrl(session.eventholder.usecase, params.url))
		{
			session.eventholder = null
			response.outputStream << "goto:" + "/logger/record/task"
			// redirect(action: "finish")
			return
		}
		
		// Dummy proxy
		if (params.url)
		{
			response.outputStream << params.url.toURL().text 
		} else
		{
			render(text: "<head></head><body>Sorry</body>")
		}
	}
	
	def task =
	{
		if (session.remaining.size() == 0)
			return redirect(controller: "record", action: "finish")
	
		session.eventholder = new Eventholder([runner: session.runner, usecase:Usecase.findById(session.remaining.pop())])
		session.eventholder.save(flush: true)
		
		[usecase: session.eventholder.usecase]
	}
	
	def finish =
    {
		session.eventholder = null;
		session.remaining = null;
		session.runner = null;
	}
	
	def event = 
	{
		Event e = new Event(params)
		// e.time = Long.parseLong(params.time)
		e.eventholder = session.eventholder
		e.save()
	}
}
