package net.klakegg.master.logger

import java.util.ArrayList;

class UsecaseController {

    def index =
	{
    	[suite:Suite.findById(params.suite)]	
	}
	
	def create =
	{
		if (params.name)
		{
			def s = new Usecase()
			s.name = params.name
			s.task = params.task
			s.startpage = params.startpage
			s.suite = Suite.findById(params.suite)
			s.save(flush: true)

			println s.dump()
			
			redirect(action:view, id:s.id, params:[suite:params.suite])
		}
		
		[suite:Suite.findById(params.suite)]	
	}
	
	def view =
	{
		def suite = Suite.findById(params.suite)
		def usecase = Usecase.findById(params.id)
		
		if (params.type == "goal")
		{
			def g = new Goal(params)
			g.usecase = usecase
			g.save(flush: true)
			
			redirect(action: view, id:usecase.id, params:[suite:suite.id])
		}
		
		[suite:suite, usecase:usecase]
	}
	
	def recordings =
	{
		def suite = Suite.findById(params.suite)
		def usecase = Usecase.findById(params.id)
		
		[suite:suite, usecase:usecase, eventholders:usecase.eventholders]
	}
	
	def recdetailed =
	{
		def suite = Suite.findById(params.suite)
		def usecase = Usecase.findById(params.id)
		def eventholder = Eventholder.findById(params.rec)
		def events = Event.findAllByEventholder(eventholder, [order:"time"])

		// println eventholder.events.set[0]
		[suite:suite, usecase:usecase, eventholder:eventholder, baseevent:events[0], events:events]				
	}
	
	def recnice =
	{
		def suite = Suite.findById(params.suite)
		def usecase = Usecase.findById(params.id)
		def eventholder = Eventholder.findById(params.rec)
		def events = Event.findAllByEventholder(eventholder, [order:"time"])

		ArrayList<Event> eventsn = []
		for (def e : events)
			if (eventsn.size() == 0 || eventsn.get(eventsn.size()-1)?.type != e.type)
				eventsn.add(e)

		// println eventholder.events.set[0]
		[suite:suite, usecase:usecase, eventholder:eventholder, baseevent:events[0], events:eventsn]				
	}
}
